/*
Environment Lighting HDR Studio (MR) 0.7 (work in progress)
 Version: 0.7
Created: first release 2015-03-16
Last Modified: 1-15-2010
Support Version: 3dsmax 9/2008/2009/2010
Author: Marcelli Michele
Code by Marcelli Michele
E-mail: Medal71@Hotmail.it
----------------------------------------- 
This Script allows to insert a Environment map HDR in the scene and simluate a virtual set for rendering "white".
----------------------------------------- 
Terms of use: 

The use of the script is an "As is". 
The author assumes no liability with regard to any kind of damage (hardware and software) caused by the use of this script. 
Are not responsible for any damage or cancellation or modification of the work, files, crash and or any problem in 3dsMax or 
computer. So if you installed the script,you accept the above conditions and declines any my responsibility. 
-----------------------------------------
--*****************************************************************************************
-- MODIFY THIS AT YOUR OWN RISK ANS SAVE YOUR WORK BEFORE USE THE SCRIPT
-- Please feel free to modify this code, but let me know so that I can benefit from the changes as well
-- Modify added, must be e-mailed to  Medal71@hotmail.it 
--*****************************************************************************************
Please let me know any bug or error!!!! 
*/



(
	global ligh_hdr
try (destroyDialog :: ligh_hdr) catch()

rollout ligh_hdr "Environment Lighting HDR Studio - Mental Ray -" width:546 height:592
(
	Global mr_plane, epcb = Environment_Probe_Chrome_Ball__mi (), bm, bm_preview, bm_epc, btext = bitmaptexture, itm, Sel_Bitmap, rm, pcp

	GroupBox grp1 "Create MR Plane" pos:[8,8] width:232 height:96
	button b1 "Create" pos:[16,32] width:137 height:21 tooltip: "Create a plane with applied Matte_Shadow_Reflection__mi material"
	button del_plane "Delete" pos:[164,32] width:66 height:51 enabled:off tooltip: "Delete the plane"
	spinner sp1 "Scale Render : " pos:[10,66] width:144 height:16 enabled:off range:[1,10000,1] type:#float fieldWidth:50 tooltip:"Specifies the factor by which both length and width are multiplied at render time. Scaling is performed from the center outward"
	checkbox chk1 "Receive Reflections" pos:[24,136] width:136 height:16 checked:off enabled:off tooltip:"When on, the surface reflects its surroundings"
	spinner spn3 "Glossiness :.......... " pos:[90,208] width:140 height:16 range:[0,1.0,8] type:#float enabled:off fieldWidth:50 tooltip:"The glossiness of reflections"
	spinner spn4 "Glossy Samples (0 = mirror) : " pos:[80,232] width:150 height:16 range:[0,1024,8] type:#integer enabled:off fieldWidth:50 tooltip:"The number of glossy-reflection samples"
	spinner spn5 "Max Distance (0 = infinite) : " pos:[80,256] width:150 height:16 range:[0,14748e+009,0] type:#float enabled:off fieldWidth:50 tooltip:"At values other than the default of 0.0, limits the distance from which reflections are cast"
	spinner spn6 "Max Distance FallOff : " pos:[86,280] width:144 height:16 range:[0.2,14748e+009,2] type:#float enabled:off fieldWidth:50 tooltip:"The falloff curve for reflections at Max Distance. Lower values cause more rapid falloff"
	colorPicker cp_rf "Reflection Color :" pos:[88,160] width:136 height:16 Color: (color 127.5 127.5 127.5) enabled:off 
	colorPicker cp_rsc "Reflections (Subtractive Color) :" pos:[24,184] width:200 height:16 color:(color 255 255 255 255) enabled:off
	GroupBox grp2 "Reflection Material MR Plane" pos:[8,112] width:232 height:200
	bitmap bmp1 "Bitmap" bitmap:(bitmap 200 128 gamma:2.2) pos:[24,344] width:200 height:128
	GroupBox grp3 "Preview" pos:[8,320] width:232 height:192
	button prev "preview" pos:[24,480] width:116 height:16 enabled:off tooltip:"Press for quick preview render scene"
	button prev_last "Last Preview" pos:[142,480] width:80 height:16 enabled:off tooltip:"Open the last saved rendering"
	button btn3 "Render!!" pos:[24,544] width:200 height:24 enabled:off tooltip:"Render the scene with  Rendered Frame Window (a.k.a Virtual Frame Buffer or VFB). The width/height measure are those set up in Render SetUp "
	GroupBox grp4 "Render VFB" pos:[8,520] width:232 height:64
---------------------------------------------------------------------------------------------------------------------------
	GroupBox grp5 "Load Image" pos:[250,8] width:288 height:56
	button b "Choose image for Environment ( best HDRi )" pos:[262,32] width:262 height:21 tooltip:"Opens the browser to choose the image to load (better HDRI)"
	GroupBox grp6 "Image Preview" pos:[250,72] width:288 height:200
	label lb_bm "Original Image" pos:[290,94] width:120 height:16
	bitmap bm "" width:128 height:128 bitmap:(bitmap 128 128 color:black) pos:[260,114] gamma:2.2
	label lb_bm_name "" pos:[264,250] width:256 height:16
	label lb_bm_preview "Mapping Image" pos:[426,94] width:80 height:16
	bitmap bm_preview "" width:128 height:128 bitmap:(bitmap 128 128 color:black) pos:[400,114] gamma:2.2
	GroupBox grp7 "Image Environment" pos:[250,280] width:140 height:120
	dropdownlist  ddl_mapping "Mapping Environment" items:#("Spherical", "Cylindrical", "Shrink-Wrap") enabled:off pos:[260,300] width:120 height:24 fieldWidth:50 tooltip:"Uses the map as an Environment map:\nSpherical Environment\nCylindrical Environment\nShrink-wrap Environment\nProjects the map into the scene as though it were mapped to an invisible object in the background "
	spinner off_U "Offset U : " range:[-100,100,0] type:#float scale:0.01 enabled:off pos:[256,350] width:120 height:24 fieldWidth:50 tooltip:"Changes the position of the map in UV coordinates. The map moves in relation to its size. For example, if you want to shift the map its full width to the left, and half its width downward from its original position, you enter 1 in the U Offset field and 0.5 in the V offset field. "
	spinner off_V "Offset V : " range:[-100,100,0] type:#float scale:0.01 enabled:off pos:[256,374] width:120 height:24 fieldWidth:50 tooltip:"Changes the position of the map in UV coordinates. The map moves in relation to its size. For example, if you want to shift the map its full width to the left, and half its width downward from its original position, you enter 1 in the U Offset field and 0.5 in the V offset field. "
	GroupBox grp8 "Image Output" pos:[398,280] width:140 height:88
	spinner tex_amount "Amount : " range:[-9999,9999,1] type:#float scale:0.01 enabled:off pos:[388,302] width:140 height:120 fieldWidth:50 tooltip:"Controls the amount of the map being mixed into a composite material. Affects the saturation and alpha value of the map"
	spinner tex_offset "RGB Offset : " range:[-9999,9999,0] type:#float scale:0.01 enabled:off pos:[388,322] width:140 height:120 fieldWidth:50 tooltip:"Adds to the RGB values of the map colors by the amount set by the spinner, which affects the tonal value of the colors. Eventually the map becomes white and self-illuminated. Lowering the value decreases the tonal value toward black"
	spinner tex_level "RGB Level : " range:[-9999,9999,1] type:#float scale:0.01 enabled:off pos:[388,342] width:140 height:120 fieldWidth:50 tooltip:"Multiplies the RGB values of the map colors by the amount set by the spinner, which affects the saturation of the color. Eventually the map becomes fully saturated and self-illuminated. Lowering the value decreases the saturation and makes the map colors grayer"

	GroupBox grp9 "Environment Probe/Chrome Ball" pos:[250,406] width:232 height:86
	
	bitmap bm_epc "" width:50 height:50 bitmap:(bitmap 50 50 color:black) pos:[260,428] gamma:2.2
	spinner multi "Multiplier :" range:[-340288e5,340288e5,0] type:#float scale:0.01 enabled:off pos:[328,434] width:140 height:120 fieldWidth:50 tooltip:"A multiplier for the chrome ball image. "
	spinner reverseGC "Reverse Gamma :" range:[1,5,1] type:#float scale:0.01 enabled:off pos:[328,458] width:140 height:120 fieldWidth:50 tooltip:"Applies an inverse gamma correction to the texture"
	button bit_info "Info Image..." pos:[399,376] width:138 height:21 tooltip:"Information about the map in use (path, measure, name, gamma ecc.)"
	button note "Note's" pos:[488,418] width:50 height:68 enabled: false

	button clear_env "Clean Environmet"  pos:[254,500] width:280 height:21 tooltip:"Delete and restore the parameters for Environment"
	button _clos "Exit" pos:[400,560] width:130 height:21
	button _about "About..." pos:[263,560] width:130 height:21
	
	---------------------------------------------------
	---------------------------------------------------
	
	-- ***use this FN to remove all global var that you created vith this tool. Put this in rollout close event (barigazy tips and function).
	fn removeGlobals globalArr:#(#mr_plane, #epcb, #bm, #bm_preview, #bm_epc, #btext, #itm, #Sel_Bitmap, #rm, #pcp) =
	(
		for name in globalArr where globalVars.isglobal name do globalVars.remove name
	)
	---
	--
	---
	fn defPlaneCA node = --***CA definition for a plane. Create similar function for the environment map (barigazy tips and function).
	(
		local mrpCA = attributes mr_plane_ca
		(
			rollout mpRoll "MR Plane" Category:1 -- Note the Category:1, this is what makes the rollout appear at the top
			(
				label lbl "Author: Michele71" Width:154 Align:#Center style_sunkenedge:on
				hyperLink hl "michele71.treddi" color:orange address:"http://michele71.treddi.com/"
			)
		)
		custAttributes.add node mrpCA baseobject:on
	)
	---
	--
	---
	fn EnvCA node = -- CA definition for Environment Map
	(
	local envImageCA = attributes epcb_ca
	(
		rollout envRoll "Env Image" Category:1
		(
			label lbl "Environment Lighting HDR Studio Map" Align:#Center 
				hyperLink hl "michele71.treddi" color:orange address:"http://michele71.treddi.com/" Align:#Center 
		)
	)
	custAttributes.add node envImageCA baseobject:on
	)
	---
	--
	---
		fn LastPreview = -- get and open the last rendering preview
	(
				files = getFiles  (getDir #preview + "\\RenderPreview_image.tga")
				if files.count != 0 then
				(
				dir_renderPreview = (getDir #preview + "\\RenderPreview_image.Tga")
				ligh_hdr.bmp1.bitmap = openbitmap dir_renderPreview
				)
				else (messagebox "No render preview image found")
	)
	---
	--
	---
	fn getMRPlaneData mrp = -- store date of plane
	(
		if (isValidNode mrp and isKindOf ligh_hdr RolloutClass) do
		(
			ligh_hdr.del_plane.enabled = on
			ligh_hdr.sp1.enabled = on ; ligh_hdr.sp1.value = mrp.renderScale
			if isKindOf mrp.mat Matte_Shadow_Reflection__mi do
			(
				ligh_hdr.chk1.enabled = on ; ligh_hdr.chk1.checked = mrp.mat.catch_reflections
				ligh_hdr.cp_rf.enabled = on ; ligh_hdr.cp_rf.color = mrp.mat.refl_color
				ligh_hdr.cp_rsc.enabled = on ; ligh_hdr.cp_rsc.color = mrp.mat.refl_subtractive
				ligh_hdr.spn3.enabled = on ; ligh_hdr.spn3.value = mrp.mat.refl_glossiness
				ligh_hdr.spn4.enabled = on ; ligh_hdr.spn4.value = mrp.mat.refl_samples
				ligh_hdr.spn5.enabled = on ; ligh_hdr.spn5.value = mrp.mat.refl_max_dist
				ligh_hdr.spn6.enabled = on ; ligh_hdr.spn6.value = mrp.mat.refl_falloff
				ligh_hdr.prev.enabled = ligh_hdr.btn3.enabled = on
				ligh_hdr.prev_last.enabled = on
				ligh_hdr.b1.enabled = off
				ligh_hdr.prev_last.enabled = on
					--
                 LastPreview()
			)
		)
	)
	---
	--
	---
	fn refreshSceneMaterials = -- save/delete the scene and refresh material 
    (
	tmpFile = (getdir #export + "\del.max")
	savenodes #() tmpFile
	deletefile tmpFile
	)
	---
	--
	---
	fn PreviewImage = --- Function image preview
	(
		rm = rendermap  epcb.texture_shader size:[128,128] fileName:(getDir #preview + "\\Preview_image.bmp") gamma:2.2
		save rm
		bm_preview.bitmap = rm
		freescenebitmaps()
		close rm
	) --- end Function image preview
	---
	--
	---
	fn ProbeChromePreviewImage = --- Function for probe chrome image preview
	(
		pcp = rendermap  epcb size:[50,50] fileName:(getDir #preview + "\\ProbeChromePreview_image.bmp") 
		save pcp
		bm_epc.bitmap = pcp
		freescenebitmaps()
		close pcp
	)
	---
	--
	---
	fn DeletePlane = -- delete and restore data for the plane
	(          
               obj_= mr_plane; print obj_
               ca_def =custattributes.getdef obj_  1 ; print ca_def
               cad = custAttributes.delete obj_  ca_def; print cad
			   delete mr_plane
		       ligh_hdr.b1.enabled = on
			   ligh_hdr.sp1.enabled = off ; ligh_hdr.sp1.value = 1.0
				ligh_hdr.chk1.enabled = off ; ligh_hdr.chk1.checked = off
				ligh_hdr.cp_rf.enabled = off
				ligh_hdr.cp_rsc.enabled = off 
				ligh_hdr.spn3.enabled = off ; ligh_hdr.spn3.value = 1.0
				ligh_hdr.spn4.enabled = off ; ligh_hdr.spn4.value = 8.0
				ligh_hdr.spn5.enabled = off ; ligh_hdr.spn5.value = 0.0
				ligh_hdr.spn6.enabled = off ; ligh_hdr.spn6.value = 2.0
				ligh_hdr.prev.enabled = ligh_hdr.btn3.enabled = ligh_hdr.prev_last.enabled = off
				bmp1.bitmap =bitmap 200 128 color:black
			    ligh_hdr.del_plane.enabled = off 
			 
	)
	---
	--
	---
	fn FindEnv = -- load data when "open do" rollout
	(
				local envArr = for m in sceneMaterials where isProperty m #epcb_ca collect m
			if envArr.count > 0 do
		(
		        epcb = envArr[1]
			    epcb_filename = epcb.texture_shader.filename
			    getBitmapInfo epcb_filename 
				local temp_bitmap_filename = (getDir #preview +"/Temp2.bmp")
			    local new_temp_bitmap = bitmap 128 128 filename:temp_bitmap_filename gamma:2.2
			    open_pathImage = openBitMap epcb_filename
			    copy open_pathImage new_temp_bitmap
			    save new_temp_bitmap 
			    bm.bitmap =  new_temp_bitmap 
				close new_temp_bitmap
			    free new_temp_bitmap
			    deleteFile temp_bitmap_filename
				dir_imagepreview = (getDir #preview + "\\Preview_image.bmp")
			    ligh_hdr.bm_preview.bitmap = openbitmap dir_imagepreview
			    ---
				ligh_hdr.ddl_mapping.enabled = on; ligh_hdr.ddl_mapping.selection  = epcb.texture_shader.coords.mapping +1
				ligh_hdr.off_U.enabled = on;  ligh_hdr.off_U.value =epcb.texture_shader.coords.u_offset
	            ligh_hdr.off_V.enabled = on;   ligh_hdr.off_V.value = epcb.texture_shader.coords.v_offset
				ligh_hdr.tex_amount.enabled = on; ligh_hdr.tex_amount.value = epcb.texture_shader.output.output_amount
	            ligh_hdr.tex_offset.enabled = on; ligh_hdr.tex_offset.value = epcb.texture_shader.output.RGB_Offset 
	            ligh_hdr.tex_level.enabled = on; ligh_hdr.tex_level.value = epcb.texture_shader.output.RGB_Level
				ligh_hdr.lb_bm_name.text = epcb.texture_shader.name as string
				ligh_hdr.note.enabled = on
				---
				ligh_hdr.multi.enabled = on; ligh_hdr.multi.value = epcb.Multiplier
				ligh_hdr.reverseGC.enabled = on; ligh_hdr.reverseGC.value = epcb.degamma
				dir_ProbeChrome_imagepreview = (getDir #preview + "\\ProbeChromePreview_image.bmp")
			    ligh_hdr.bm_epc.bitmap = openbitmap dir_ProbeChrome_imagepreview
				---
				PreviewImage(); ProbeChromePreviewImage()
		)
	)

	------End all Function --------------------------------------------------------------------------\\\\\\
	
	-----  Start Create MR Plane  ------------------
	
	on b1 pressed do
	(
		mr_plane = Plane name:"mrPlane" length:25.0 width:25.0 lengthsegs:1 widthsegs:1 renderScale:sp1.value
		mr_plane.material = Matte_Shadow_Reflection__mi Background:(color 255 255 255 0) ao_on:on ao_samples:64 ao_distance:0
		--- enable UI
		sp1.enabled = chk1.enabled = spn3.enabled = spn5.enabled = spn4.enabled = spn6.enabled = cp_rf.enabled = cp_rsc.enabled = prev.enabled = btn3.enabled =del_plane.enabled = prev_last.enabled = prev_last.enabled = on
		b1.enabled = off
		defPlaneCA mr_plane -- ***assigne CA to plane
	)
	
	on sp1 changed val do if isValidNode mr_plane do
	(
		mr_plane.renderScale = sp1.value
	)
	--- end Create MR Plane
	--
	--- Start Delete Plane
	on del_plane pressed do
	(
		DeletePlane()
	)
	---End Delete Plane
	--
	--- Start Reflection Material MR Plane
	on chk1 changed state do if isValidNode mr_plane do
	(
		mr_plane.material.catch_reflections = state
	)
	on cp_rf changed new_col do (if isValidNode mr_plane do mr_plane.material.refl_color = new_col)
	on cp_rsc changed new_col do (if isValidNode mr_plane do mr_plane.material.refl_subtractive = new_col)
	on spn3 changed val do (if isValidNode mr_plane do mr_plane.material.refl_glossiness = val)
	on spn4 changed val do (if isValidNode mr_plane do mr_plane.material.refl_samples = val)
	on spn5 changed val do (if isValidNode mr_plane do mr_plane.material.refl_max_dist = val)
	on spn6 changed val do (if isValidNode mr_plane do mr_plane.material.refl_falloff = val)
	--- end Reflection Material MR Plane
	--
	--- Start Render Preview
	on prev pressed do
	(
		prev.text = "Render in Progress..." 
		StartTime = TimeStamp ()
		local new_re_prew = bitmap 200 128 fileName:(getDir #preview + "\\RenderPreview_image.Tga") gamma:2.2
		local re_prew  = render outputsize:[200, 128] vfb:off fileName:new_re_prew -- render the active view
		copy re_prew new_re_prew
		save new_re_prew
		bmp1.bitmap = new_re_prew
		EndTime = TimeStamp ()
		prev.text = "Finished in " + ((EndTime-StartTime)/1000.0) as string + " sec."
		freescenebitmaps()
		close re_prew
	)
	--- End Render Preview
	--
	--- Start Last Render previw
	on prev_last pressed do LastPreview()
	--- End Last Render previw
	--
	--- Start Render VFB
	on btn3 pressed do (render outputsize:[renderWidth, renderHeight] vfb:on)
	--- End Render VFB
	--
    --
	----- Start Image Environment zone ------------------

	on b pressed do
	(
		ProbeChromePreviewImage()
		environmentmap = epcb -- set map Environment Probe Chrome Ball in environment slot (Environment and Effect)
		Sel_Bitmap = selectbitmap() -- open browse image for imput
		if Sel_Bitmap != undefined then -- if Sel_Bitmap is defined then..
		(
			Info = getBitmapInfo Sel_Bitmap  -- get info from image
			ffp = getFilenameFile  -- take name of bitmap from path
			local temp_new_bitmap_filename = (getDir #preview +"/Temp.bmp") -- create new temp bitmap
			local new_bitmap = bitmap 128 128 filename:temp_new_bitmap_filename gamma:2.2 -- create bitmap file
			cnb = copy Sel_Bitmap new_bitmap -- copy the open image in to the new_bitmap
			save new_bitmap -- save new_bitmap
			bm.bitmap =  new_bitmap -- preview new_bitmap in bitmap rollout
			lb_bm_name.text = ffp (Sel_Bitmap as string) -- label name get from image

			--- Start Environment map Chrome/Mirror
	        epcb.texture_shader = btext fileName:(Info[1] as string) -- copy image to map Environment Probe Chrome Ball
			epcb.texture_shader.name = ffp (Sel_Bitmap as string)
			epcb.texture_connected = on -- active the map 
			epcb.texture_shader.coords.mappingType = 1 -- type of ccords. (environment = 1)
			epcb.texture_shader.coords.mapping = 0 -- type of coords. map (sphere=0, cylinder=1, wrap=2)
			
			local rm = rendermap  epcb.texture_shader size:[128,128] fileName:(getDir #preview + "\\Preview_image.bmp") -- render the map and create a bitmap
			save rm -- save bitmap 
			bm_preview.bitmap = rm -- -- preview new_bitmap in bitmap rollout
			close cnb; new_bitmap
			free cnb; new_bitmap
			deleteFile temp_new_bitmap_filename -- delete the temp bitmap
			freescenebitmaps() -- clear, restore and free image data
			--- End Environment map Chrome/Mirror
			--
			--- Preview rendering Probe/Chrome Ball
				dir_ProbeChrome_imagepreview = (getDir #preview + "\\ProbeChromePreview_image.bmp")
			    ligh_hdr.bm_epc.bitmap = openbitmap dir_ProbeChrome_imagepreview
			ProbeChromePreviewImage()
			---
			--
			--- enable UI
			ddl_mapping.enabled = off_U.enabled = off_V.enabled = tex_amount.enabled = tex_offset.enabled = tex_level.enabled = multi.enabled = reverseGC.enabled = note.enabled = on
			ligh_hdr.ddl_mapping.selection = 1
			ligh_hdr.off_U.value =0.0
			ligh_hdr.off_V.value = 0.0
			ligh_hdr.tex_amount.value = 1.0
			ligh_hdr.tex_offset.value = 0.0
			ligh_hdr.tex_level.value = 1.0
			ligh_hdr.multi.value = 1.0
			ligh_hdr.reverseGC.value = 1.0
			
			--- end enable UI
			EnvCA epcb -- apply custom attribute in environment map
			
			
			
		)
		else (ddl_mapping.enabled = off_U.enabled = off_V.enabled = tex_amount.enabled = tex_offset.enabled = tex_level.enabled = multi.enabled = reverseGC.enabled = note.enabled = on)

	)
	---
	--
	--- Start choose Mapping Environment
	on ddl_mapping selected itm do 
	(
		case itm of
		(
			1: (epcb.texture_shader.coords.mapping = 0 ; PreviewImage();ProbeChromePreviewImage())
			2: (epcb.texture_shader.coords.mapping = 1 ; PreviewImage();ProbeChromePreviewImage())
			3: (epcb.texture_shader.coords.mapping = 2 ; PreviewImage();ProbeChromePreviewImage())
		)
	)
	--- End choose Mapping Environment
	--
	--- Start Offset mapping Environment
	on off_U changed val do (epcb.texture_shader.coords.u_offset = val ; PreviewImage();ProbeChromePreviewImage())
	on off_V changed val do (epcb.texture_shader.coords.v_offset = val ; PreviewImage();ProbeChromePreviewImage())
	--- End Offset mapping Environment
	--
	--- Start Image Output 
	on tex_amount changed val do (epcb.texture_shader.output.output_amount = val ; PreviewImage();ProbeChromePreviewImage())
	on tex_offset changed val do (epcb.texture_shader.output.RGB_Offset = val ; PreviewImage();ProbeChromePreviewImage())
	on tex_level changed val do (epcb.texture_shader.output.RGB_Level = val ; PreviewImage();ProbeChromePreviewImage())
	--- End Image Output 
	--
	--- Start Environment Probe/Chrome Ball
	
	on multi changed val do (epcb.Multiplier = val ; ProbeChromePreviewImage();ProbeChromePreviewImage())
	on reverseGC changed val do (epcb.degamma = val ; ProbeChromePreviewImage();ProbeChromePreviewImage())
	--- End Environment Probe/Chrome Ball
	--
	--- Start bitmap Info
		on bit_info pressed do
		(
			try (destroydialog ::info_bitmap) catch()
			rollout info_bitmap "Image Information" width:300 height:230
			(
				groupBox grp1 "Image..." pos:[4,7] width:292 height:185
				edittext ed1 "Path: " pos:[10,26] width:276 height:13
				label lab1 "" pos:[10,46] width:200 height:13
				label lab2 "" pos:[10,64] width:200 height:13
				label lab3 "" pos:[10,82] width:200 height:13
				label lab4 "" pos:[10,100] width:200 height:13
				label lab5 "" pos:[10,118] width:200 height:13
			    label lab6 "" pos:[10,136] width:200 height:13
				label lab7 "" pos:[10,154] width:200 height:13
				label lab8 "" pos:[10,172] width:200 height:13
				button ex "Close" pos:[10,200] width:280 height:21
				
				on ex pressed do destroydialog info_bitmap

				on info_bitmap open do
				(
				local envArr = for m in sceneMaterials where isProperty m #epcb_ca collect m
			if envArr.count > 0 do
		(
		        epcb = envArr[1]
			    epcb_filename = epcb.texture_shader.filename
			    gbi = getBitmapInfo epcb_filename
				ed1.text = gbi[1] as string
			    lab1.text = "File Name: " + getFilenameFile (gbi[1] as string)
			    lab2.text = "File type: " + gbi[2] as string
			    lab3.text = "Measure: " + ("Width: " + gbi[3] as string)+ ("  Height: " + gbi[4] as string)
			    lab4.text = "RGB bit: " + gbi[5] as string
			    lab5.text = "Aspect ratio: " + gbi[7] as string
			    lab6.text = "Gamma: " + gbi[8] as string
			    lab7.text = "Alpha: " + gbi[9] as string
				lab8.text = "Animation: " + ("First Frame: " + gbi[10] as string) +( "  Last Frame: " + gbi[11] as string)
		)
				)
			)
			createdialog info_bitmap style:#(#style_titlebar, #style_sysmenu, #style_toolwindow, #style_sunkenedge)
		)
	--- End bitmap info
	--
	--- Start block Note's
		on note pressed do 
	(
	local txt_path  = ((getDir #export)+ "\\E.L.HDRi Studio Setting.txt") -- get the dri. to save txt file
	txt = createFile  txt_path -- crate the txt file
	--- 
	format "--- Create Mental Ray Plane ---\n\n" to:txt
	format "Scale Render: %\n" ligh_hdr.sp1.value to:txt
	format "Receive Reflections check: %\n"  ligh_hdr.chk1.checked to:txt
	format "Reflection Color: %\n"  ligh_hdr.cp_rf.color to:txt
	format "Reflections (Subactive Color): %\n" ligh_hdr.cp_rsc.color  to:txt
	format "Glossines: %\n" ligh_hdr.spn3.value to:txt
	format "Glossy Sample: %\n"  ligh_hdr.spn4.value to:txt
	format "Max Distance: %\n"   ligh_hdr.spn5.value to:txt
	format "Max Distance FallOff: %\n\n"  ligh_hdr.spn6.value to:txt 
    format "--- Create Environment ---\n\n" to:txt
	format "Path Image: %\n\n" (epcb.texture_shader.filename as string) to:txt
    format "--- Image Environment ---\n\n" to:txt
	format "Mapping Environmet: %\n"  ligh_hdr.ddl_mapping.selection to:txt
	format "OffSet U: %\n"  ligh_hdr.off_U.value to:txt
	format "OffSert V: %\n\n"  ligh_hdr.off_V.value to:txt
    format "--- Image OutPut ---\n\n"  to:txt
    format "Amount: %\n"  ligh_hdr.tex_amount.value to:txt
	format "RGB OffSet: %\n" ligh_hdr.tex_offset.value to:txt
	format "RGB Level: %\n\n"  ligh_hdr.tex_level.value to:txt
	format "--- Environment Probe/Chrome Ball ---\n\n" to:txt
    format "Multiplier: %\n" ligh_hdr.multi.value to:txt 	
	format "Reverse Gamma: %\n" ligh_hdr.reverseGC.value to:txt
	---
	close txt
	
	try (destroydialog ::texttoList) catch()
	rollout texttoList "Summary Value HDR Studio"
    (
	multilistbox ViewMtl "" items:#() width:284 height:18
	button exitList "Close" width:280 height:21
--
	on exitList pressed do (destroydialog texttoList)
	---
	--
	---
	on texttoList open do
(
		ViewMtl.items =  #() -- reset list
		local listArray = #() -- create empty array for the list
		open_file =((getDir #export) + "\\E.L.HDRi Studio Setting.txt") -- get dir. txt file 
		fileS = openFile open_file -- open txt file with parameters
		while not eof fileS do
		(
			lineInfo = readLine fileS -- read line txt file 
			append listArray lineInfo -- stamp the line to empty array
		)
		close fileS  -- close file
	
		-- Start write the value in items multilistbox
		for i = 1 to listarray.count do
		(
			ViewMtl.items = append ViewMtl.items (listArray[i] as string)
		)
		--  End write the value in items multilistbox
)
	   )
createDialog texttoList 310 280 style:#(#style_titlebar, #style_sysmenu, #style_toolwindow, #style_sunkenedge)

deletefile txt_path
)
	--- End Block Note's
	--
	--- Start Clear Environment
	on clear_env pressed do
	(

		local envArr = for m in sceneMaterials where isProperty m #epcb_ca collect m  -- array material scene
			if envArr.count > 0 do
		(
			  -- Removing custom attributes 
                 mater = environmentmap; print mater -- store the material with custom attributes 
                 mat_CA = custattributes.getdef mater 1; print mat_CA -- get the first custom attribute definition
                 cad_m = custAttributes.delete mater mat_CA; print cad_m -- delete that custom attribute on material
			  -- End removing custom attributes 
			    environmentmap = undefined
				ligh_hdr.ddl_mapping.enabled = off; ligh_hdr.ddl_mapping.selection  = 1
				ligh_hdr.off_U.enabled = off;  ligh_hdr.off_U.value = 0.0
	            ligh_hdr.off_V.enabled = off;   ligh_hdr.off_V.value = 0.0
				ligh_hdr.tex_amount.enabled = off; ligh_hdr.tex_amount.value = 1.0
	            ligh_hdr.tex_offset.enabled = off; ligh_hdr.tex_offset.value = 0.0
	            ligh_hdr.tex_level.enabled = off; ligh_hdr.tex_level.value = 1.0
				---
				ligh_hdr.multi.enabled = off; ligh_hdr.multi.value = 1.0
				ligh_hdr.reverseGC.enabled = off; ligh_hdr.reverseGC.value = 1.0
				---
			    bm.bitmap =bitmap 128 128 color:black
			    bm_preview.bitmap = bitmap 128 128 color:black
			    bm_epc.bitmap = bitmap 50 50 color:black
			    lb_bm_name.text = ""
			ligh_hdr.note.enabled = off
		)
		medit_Arr = for mm in meditmaterials where isProperty mm #epcb_ca collect mm
			if medit_Arr.count > 0 do
		(	
		for o = 1 to 24 do
		(
		if superclassof meditmaterials[o] == texturemap and classof Environment_Probe_Chrome_Ball__mi == texturemap do 
            (
	           print o
	             meditmaterials[o] =standardmaterial()
            )
		)
	     )
	refreshSceneMaterials()
	)
	--- End Clear Environment
    ----- End Image Environment zone ------------------
	--
    --- Start close rollout
	on _clos pressed do destroydialog ligh_hdr
	--- Endo close rollout
	--
	--- Start About
	on _about pressed do 
	(
		rollout _info "About..." width:272 height:176
		(
			label lbl2 "Environment Lighting HDR Studio (MR)" pos:[48,32] width:220 height:13 
			label lbl3 "by Michele71" pos:[103,50] width:63 height:13 
			label lbl4 "Medal71@hotmail.it" pos:[88,68] width:93 height:13
			label lbl5 "For 3dsMax 2010 and more recent versions" pos:[32,88] width:216 height:13 
			HyperLink mychannelyoutube "My channel YouTube" pos:[83,112] width:102 height:15 color:(color 0 255 0) visitedcolor:(color 0 255 0) address:"http://www.youtube.com/user/Medal71?feature=mhee"
			GroupBox grp2 "About..." pos:[8,8] width:256 height:160
			button btn_exit "Exit" pos:[16,144] width:240 height:16

			on btn_exit pressed do destroydialog _info
		)
		createdialog _info
	)
	--- End About
	--
	--- When the rolluot open
	on ligh_hdr open do
	(
		mp = matchPattern (renderers.current as string) pattern:"*mental*" -- Search the word within the current mental render engine
		if mp then createdialog ligh_hdr else-- if mental is not found ...
		(
			messagebox ("The current Render Engine is: \n\n" + (filterString (renderers.current as string) ":")[1] + "\n\n Please, change in MentalRay Engine") title:"Michele71_Tools"
			q = querybox ("You want to change in Mental Ray?") title:"Michele71_Tools" beep: true

			if q then 
			(
				renderers.current = mr = mental_ray_renderer()
				destroydialog ligh_hdr
				createdialog ligh_hdr
			) 
			else destroydialog ligh_hdr
		)
		---
		--
		---***check if is mr_plane already created and recive rollout data (barigazy tips and function).
		local mrpArr = for o in geometry where isProperty o #mr_plane_ca collect o
		if mrpArr.count > 0 do
		(
			mr_plane = mrpArr[1]
			getMRPlaneData mr_plane
		)
		
           FindEnv(); refreshSceneMaterials()
	)
    --- end open rollout
	--
	--- When the rollout is closed...
	on ligh_hdr close do (removeGlobals() ; freeSceneBitmaps() ; gc())
	--- End the rollout closed...
)
createdialog ligh_hdr  style:#(#style_titlebar, #style_sysmenu, #style_toolwindow, #style_sunkenedge)
)
